/* 
 * teclado ps/2  a morse
 * seta43
 * Juan Galaz
 * http: / / seta43.duckdns.org
 * http: / / seta43.blogspot.com 
 * 11/11/2020
*/


char cmorse[]{
'A',2,0b01,
'B',4,0b1000,
'C',4,0b1010,
'D',3,0b100,
'E',1,0b0,
'F',4,0b0010,
'G',3,0b110,
'H',4,0b0000,
'I',2,0b00,
'J',4,0b0111,
'K',3,0b101,
'L',4,0b0100,
'M',2,0b11,
'N',2,0b10,
'O',3,0b111,
'P',4,0b0110,
'Q',4,0b1101,
'R',3,0b010,
'S',3,0b000,
'T',1,0b1,
'U',3,0b001,
'V',4,0b0001,
'W',3,0b011,
'X',4,0b1001,
'Y',4,0b1011,
'Z',4,0b1100,
'0',5,0b11111,
'1',5,0b01111,
'2',5,0b00111,
'3',5,0b00011,
'4',5,0b00001,
'5',5,0b00000,
'6',5,0b10000,
'7',5,0b11000,
'8',5,0b11100,
'9',5,0b11110,
};


   
#include <PS2Keyboard.h>
const int DataPin = 8;
const int IRQpin =  3;
PS2Keyboard keyboard;


#include "olex.h"
#include <Wire.h>



int y;
int Umorse=250;
char VARI[30];

void setup() 
{
 
  pinMode(13, OUTPUT);
  keyboard.begin(DataPin, IRQpin);

  Wire.begin();
  OleInit();
  xclearDisplay();  
  ModeFont=0;   
  xStringAT(0,0,(char *)"MORSE");
  setaFre9(3,125);
  
  setaFre9on();  delay(100); setaFre9off();
  Serial.begin(9600);
  Serial.println("MORSE");
}

void loop() 
{
 char c;
  if (keyboard.available()) 
  {
     c= keyboard.read();
    Serial.print("->");Serial.print(c); Serial.print("  ");
    signalM(c);   
  }
}




void signalM(char c)
{
  int z,n,x,e;
  
    if(c>96 && c<123) c-=32;
    for(z=0;z<108;z+=3)
    {
      if(c==32)
        {
          delay(Umorse*7);
          return;
        }
      if(c=='-')
        {
          if(Umorse>60)Umorse-=20;
          xclearDisplay();
          sprintf(VARI,"TIME %d",Umorse);
          ModeFont=2; xStringAT(0,0,VARI);
          return;
        }
      if(c=='+')
        {
          if(Umorse<300)Umorse+=20;
          xclearDisplay();
          sprintf(VARI,"TIME %d",Umorse);
          ModeFont=2; xStringAT(0,0,VARI);   
          return;
        }
        
      if(c==cmorse[z])
        {
          xclearDisplay();
          ModeFont=0;   xStringAT(0,0,(char *)"MORSE");
          ModeFont=2;
          xCaracterAT(0,2,cmorse[z]); 
          y=0;
          
          Serial.print(cmorse[z]);  Serial.print("  ");
          Serial.print(cmorse[z+1],DEC);  Serial.print("  ");
          Serial.println(cmorse[z+2],BIN);
          n=5-cmorse[z+1];
          x=cmorse[z+2]<<n;
          e=cmorse[z+1];
          while(e>0)
          {
            if( (x&16)==0)
                punto();
                else
                raya();
            x=x<<1;
            e--;
          }
          Serial.println(" ");
          goto salir;
        }
    }
    Serial.println("ERROR");

 salir: 
     delay(Umorse*3);
}

void punto()
{
  Serial.print(".");
  xCaracterAT(y,4,'.'); y+=2;
  digitalWrite(13, HIGH);
  setaFre9on();
  delay(Umorse);
  digitalWrite(13, LOW);
  setaFre9off();
  delay(Umorse);
}

void raya()
{
  Serial.print("-");
  xCaracterAT(y,4,'_'); y+=2;
  digitalWrite(13, HIGH);
  setaFre9on();
  delay(Umorse*3);
  digitalWrite(13, LOW);
  setaFre9off();
  delay(Umorse);
}


//_____________________________________________________

//Calculo  8Mhz/(prescaler*retardo)
//Prescaler
/*
 * 0-Stop
 * 1-/1
 * 2-/8
 * 3-/64
 * 4-/256
 * 5-/1024
 */
void setaFre9(unsigned char prescaler,unsigned char retardo)
{
  pinMode(9, OUTPUT);

  // Clear Timer on Compare Match (CTC) Mode
  bitWrite(TCCR1A, WGM10, 0);
  bitWrite(TCCR1A, WGM11, 0);
  bitWrite(TCCR1B, WGM12, 1);
  bitWrite(TCCR1B, WGM13, 0);

  // prescaling
  if(prescaler&1)
      bitWrite(TCCR1B, CS10, 1);
      else
      bitWrite(TCCR1B, CS10, 0);
  if(prescaler&2)
      bitWrite(TCCR1B, CS11, 1);
      else
      bitWrite(TCCR1B, CS11, 0);
  if(prescaler&4)
      bitWrite(TCCR1B, CS12, 1);
      else
      bitWrite(TCCR1B, CS12, 0);

  OCR1A = retardo;    // 40KHz
  OCR1B = retardo;
}

void setaFre9on(void)
{
  // Toggle OC1A and OC1B on Compare Match.
  bitWrite(TCCR1A, COM1A0, 1);
  bitWrite(TCCR1A, COM1A1, 0);
  bitWrite(TCCR1A, COM1B0, 1);
  bitWrite(TCCR1A, COM1B1, 0);
}

void setaFre9off(void)
{
  // Toggle OC1A and OC1B on Compare Match.
  bitWrite(TCCR1A, COM1A0, 0);
  bitWrite(TCCR1A, COM1A1, 0);
  bitWrite(TCCR1A, COM1B0, 0);
  bitWrite(TCCR1A, COM1B1, 0);
}





  
